CodeForces - 236C. LCM Challenge

LCM Challenge

Some days ago, I learned the concept of LCM (least common multiple). I’ve played with it for several times and I want to make a big number with it.

But I also don’t want to use many numbers, so I’ll choose three positive integers (they don’t have to be distinct) which are not greater than n. Can you help me to find the maximum possible least common multiple of these three integers?

Input

The first line contains an integer n (1 ≤ n ≤ 106) — the n mentioned in the statement.

Output

Print a single integer — the maximum possible LCM of three not necessarily distinct positive integers that are not greater than n.

Examples

Input
9
Output
504
Input
7
Output
21

Tips

题意:
给定一个正整数 n n n ,求用不大于 n n n 的三个正整数(可以有相同)能组成的最小公倍数的最大值。

题解:
法一:
最终的答案一定在 n n n 的附近,因此可以确定一个小范围然后暴力一波。

法二:
首先考虑 n n n 的奇偶性。
n n n 是奇数,则 n , n − 1 , n − 2 n,n-1,n-2 n,n1,n2 两两互质,因此这三个数的积即为所求。
n n n 是偶数,则 n , n − 1 , n − 2 n,n-1,n-2 n,n1,n2 三个数就不能选了,因为 n n n n − 2 n-2 n2 有公因子 2 2 2 ,不划算。考虑换一个积比这个组合小但彼此互质的组合。首先想到 n , n − 1 , n − 3 n,n-1,n-3 n,n1,n3 。这里还要再考虑 n n n 是否是 3 3 3 的倍数。 若 n n n 不是 3 3 3 的倍数,很好,彼此互质,即为所求。若是,则还要再考虑一个积更小的组合,想到 n − 1 , n − 2 , n − 3 n-1,n-2,n-3 n1,n2,n3

综上,当 n n n 是奇数时,答案为 n ( n − 1 ) ( n − 2 ) n(n-1)(n-2) n(n1)(n2) ;当 n n n 6 6 6 的倍数时,答案为 ( n − 1 ) ( n − 2 ) ( n − 3 ) (n-1)(n-2)(n-3) (n1)(n2)(n3) ;否则,答案为 n ( n − 1 ) ( n − 3 ) n(n-1)(n-3) n(n1)(n3) 。(当 n n n 较小的时候还需要特判一下)

Reference Code

#include <cstdio>
const int MAXN=1e6+10;
typedef long long ll;
ll n,res;
int main(){
//    freopen("in.txt","r",stdin);
    scanf("%lld",&n);
    if (n<=2) res=n;
    else if (n&1) res=n*(n-1)*(n-2);
    else{
        if (n%3==0) res=(n-1)*(n-2)*(n-3);
        else res=n*(n-1)*(n-3);
    }
    printf("%lld\n",res);
    return 0;
}

//#include <cstdio>
//#include <algorithm>
//typedef long long ll;
//inline ll lcm(ll a,ll b){
//    return a*b/std::__gcd(a,b);
//}
//int n;
//ll solve(){
//    ll res=0;
//    int lowwer=std::max(1,n-100);
//    for (int i=lowwer;i<=n;++i){
//        for (int j=lowwer;j<=n;++j){
//            for (int k=lowwer;k<=n;++k){
//                res=std::max(res,lcm(lcm(i,j),k));
//            }
//        }
//    }
//    return res;
//}
//int main(){
    freopen("in.txt","r",stdin);
//    scanf("%d",&n);
//    printf("%lld\n",solve());
//    return 0;
//}
  • 0
    点赞
  • 1
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
引用\[1\]中提到了一种树形动态规划的方法来解决CodeForces - 982C问题。在这个问题中,subtree指的是子连通块,而不是子树。为了使cnt_white - cnt_black尽可能大,可以使用两次树形动态规划来求解。第一次是自底向上的过程,维护一个dp数组,表示以每个节点为根的子树中的最大连通块。第二次是自顶向下的过程,处理自底向上过程中无法包含的树链所代表的子树。在第二次遍历中,需要维护一个sum变量,用于存储树链所代表的子树的贡献。根据ans\[u\]的正负,决定是否能对相邻的子节点做出贡献。如果ans\[u\]为正,则减去dp\[v\]就是树链所代表的子树的权值。最终,ans\[u\]代表包含节点u在内的子连通块的最大权值。\[1\] 问题: CodeForces - 982C 树形DP是什么问题?如何解决? 回答: CodeForces - 982C是一个树形动态规划问题。在这个问题中,需要求解子连通块的最大权值和,使得cnt_white - cnt_black尽可能大。解决这个问题的方法是使用两次树形动态规划。第一次是自底向上的过程,维护一个dp数组,表示以每个节点为根的子树中的最大连通块。第二次是自顶向下的过程,处理自底向上过程中无法包含的树链所代表的子树。在第二次遍历中,需要维护一个sum变量,用于存储树链所代表的子树的贡献。根据ans\[u\]的正负,决定是否能对相邻的子节点做出贡献。最终,ans\[u\]代表包含节点u在内的子连通块的最大权值。\[1\] #### 引用[.reference_title] - *1* *2* [CodeForces - 1324F Maximum White Subtree(树形dp)](https://blog.csdn.net/qq_45458915/article/details/104831678)[target="_blank" data-report-click={"spm":"1018.2226.3001.9630","extra":{"utm_source":"vip_chatgpt_common_search_pc_result","utm_medium":"distribute.pc_search_result.none-task-cask-2~all~insert_cask~default-1-null.142^v91^koosearch_v1,239^v3^insert_chatgpt"}} ] [.reference_item] [ .reference_list ]

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值